#include "plugin.h"
#include <time.h>
#include <shlwapi.h>
#include <list>
#include <fstream>

#define MAX_FITTLE_PATH MAX_PATH*2

using namespace std;

BOOL OnInit();
void OnQuit();
void OnTrackChange();
void OnStatusChange();
void OnConfig();

FITTLE_PLUGIN_INFO fpi = {
	PDK_VER,
	OnInit,
	OnQuit,
	OnTrackChange,
	OnStatusChange,
	OnConfig,
	NULL,
	NULL
};

typedef struct {
	int nCount;
	char szPath[MAX_FITTLE_PATH];
	int nDay;
}ITEM;

#define DEFAULT_SURVIVAL 7

list<ITEM> Array;
char szPLPath[MAX_FITTLE_PATH] = {0};
char szDBPath[MAX_FITTLE_PATH] = {0};
UINT_PTR uTimerId = 0;
int nSurvival;

// M3Uo
void WritePlaylist(LPCSTR pszPath){
	ofstream ofs(pszPath);

	list<ITEM>::iterator i;

	for(i=Array.begin();i!=Array.end();i++){
		ofs << i->szPath << endl;
	}
	ofs.close();	// fXgN^邩炢Ȃ낤ǂƗ
	return;
}

// f[^x[Xǂݏo
void ReadDatabase(LPCSTR pszPath){
	char szLine[MAX_FITTLE_PATH];
	int nCount;
	int nDay;

	nDay = (int)time(NULL)/60/60;

	ifstream ifs(pszPath);
	ifs.getline(szLine, MAX_FITTLE_PATH);
	nCount = atoi(szLine);
	if(nCount==0) return;
	ITEM item;
	for(int i=0;i<nCount;i++){
		ifs.getline(item.szPath, MAX_FITTLE_PATH);
		ifs.getline(szLine, MAX_FITTLE_PATH);
		item.nCount = atoi(szLine);
		ifs.getline(szLine, MAX_FITTLE_PATH);
		item.nDay = atoi(szLine);
		if(item.nCount==0) break;
		if(nSurvival<0 || nDay-item.nDay<=nSurvival*24){	// ԈȏĐȂꍇ͓o^Ȃ
			Array.push_back(item);
		}
	}
	ifs.close();
	return;
}

// f[^x[Xo
void WriteDatabase(LPCSTR pszPath){
	ofstream ofs(pszPath);

	list<ITEM>::iterator i;

	ofs << Array.size() << endl;	// ACe̐o
	for(i=Array.begin();i!=Array.end();i++){
		ofs << i->szPath << endl;
		ofs << i->nCount << endl;
		ofs << i->nDay << endl;
	}
	ofs.close();
	return;
}

/* Gg|g */
BOOL WINAPI _DllMainCRTStartup(HANDLE /*hModule*/, DWORD /*dwFunction*/, LPVOID /*lpNot*/){
    return TRUE;
}

/* NɈxĂ΂܂ */
BOOL OnInit(){
	char szINIPath[MAX_FITTLE_PATH] = {0};

	// pX̎擾
	GetModuleFileName(fpi.hDllInst, szINIPath, MAX_FITTLE_PATH);
	PathRenameExtension(szINIPath, ".ini");
	lstrcpyn(szDBPath, szINIPath, MAX_FITTLE_PATH);
	PathRenameExtension(szDBPath, ".dat");
	GetPrivateProfileString("Main", "Path", "", szPLPath, MAX_FITTLE_PATH, szINIPath);
	if(!*szPLPath){
		lstrcpyn(szPLPath, szINIPath, MAX_FITTLE_PATH);
		PathRenameExtension(szPLPath, ".m3u");
	}
	nSurvival = GetPrivateProfileInt("Main", "Survival", DEFAULT_SURVIVAL, szINIPath);

	ReadDatabase(szDBPath);

	return TRUE;
}

/* IɈxĂ΂܂ */
void OnQuit(){
	WriteDatabase(szDBPath);
	Array.clear();
	return;
}

VOID CALLBACK TimerProc(HWND /*hWnd*/, UINT /*uMsg*/, UINT /*idEvent*/, DWORD /*dwTime*/){
	char *pszPath;
	ITEM item = {0};
	list<ITEM>::iterator i;

	// pX̎擾
	pszPath = (char *)SendMessage(fpi.hParent, WM_FITTLE, GET_PLAYING_PATH, 0);
	lstrcpy(item.szPath, pszPath);
	item.nCount = 1;
	item.nDay = (int)time(NULL)/60/60;	// b->

	// pX̌
	for(i=Array.begin();i!=Array.end();i++){
		if(!lstrcmpi(i->szPath, pszPath)){
			item.nCount = i->nCount+1;
			Array.erase(i);
			break;
		}
	}

	// }ʒǔ
	for(i=Array.begin();i!=Array.end();i++){
		if(i->nCount<=item.nCount) break;
	}
	Array.insert(i, item);

	// t@Cɏ
	WritePlaylist(szPLPath);
	WriteDatabase(szDBPath);

	// ^C}[폜
	KillTimer(NULL, uTimerId);
	uTimerId = 0;

	// For Debugging
	//MessageBeep(MB_OK);

	return;
}

/* Ȃς鎞ɌĂ΂܂ */
void OnTrackChange(){
	if(uTimerId) KillTimer(NULL, uTimerId);
	int nLen = (int)SendMessage(fpi.hParent, WM_FITTLE, GET_DURATION, 0);
	uTimerId = SetTimer(NULL, 0, nLen*1000/2, TimerProc);	// Ȃ̔ŃCxgĂ΂悤ɂ
	return;
}

/* ĐԂς鎞ɌĂ΂܂ */
void OnStatusChange(){
	if(uTimerId!=0){
		int nStatus = (int)SendMessage(fpi.hParent, WM_FITTLE, GET_STATUS, 0);
		if(nStatus==0){
			KillTimer(NULL, uTimerId);
			uTimerId = 0;
		}
	}
	return;
}

/* ݒʂĂяo܂ij*/
void OnConfig(){
	return;
}

#ifdef __cplusplus
extern "C"
{
#endif
__declspec(dllexport) FITTLE_PLUGIN_INFO *GetPluginInfo(){
	return &fpi;
}
#ifdef __cplusplus
}
#endif
